'''
Created on 06/04/2011

@author: emea
'''

#import pygame
#from pygame.sprite import Sprite
#import AnimatedSprite
#import SpriteSheet
#import os
import Instruction
import random
#import Dancer

class Computer(object):
    (DANCING, END_DANCING) = range(2)
    def __init__(self, dancer):
        self.instructions = []
        self.state = self.END_DANCING
        self.counter = 10
        self.dancer = dancer

        
    def generate_instructions(self, player_score, com_score):
    
        # if round 1 
        if player_score + com_score == 0: # player 0 - 0 com
            # easy
            self.create_instructions_easy()
            
        # if round 2
        elif player_score + com_score == 1:
            if player_score < com_score: # player 0 - 1 com
                # easy
                self.create_instructions_easy()
                
            else: # player 1 - 0 com
                # medium
                self.create_instructions_medium()
        # if round 3
        elif player_score + com_score == 2:
            dif = player_score - com_score
            if dif == 0: # player 1 - 1 com
                # medium or easy
                if random.randint(0,9) >= 5:
                    self.create_instructions_easy()
                else:
                    self.create_instructions_medium()
        
            elif dif == 2: # player 2 - 0 com
                # hard
                self.create_instructions_hard()
                
            elif dif == -2: # player 0 - 2 com
                # easy
                self.create_instructions_easy()
                
        # if round 4
        elif player_score + com_score == 3:
            dif = player_score - com_score
            if dif == 1: # player 2 - 1 com
                # medium or easy
                self.create_instructions_medium()
                
            elif dif == 3: # player 3 - 0 com
                # hard
                self.create_instructions_hard()
                
            elif dif == -3 or dif == -1: # player 0 - 3 com  OR player 1 - 2 com
                # easy
                self.create_instructions_easy()  
                
        # if round 5
        elif player_score + com_score == 4:
            dif = player_score - com_score
            if dif == 0: # player 2 - 2 com
                # medium or easy
                if random.randint(0,9) >= 5:
                    self.create_instructions_easy()
                else:
                    self.create_instructions_medium()
                
            elif dif == 4 or dif == 2: # player 3 - 0 com OR player 2 - 1 com
                # hard
                self.create_instructions_hard()
                
            elif dif == -4 or dif == -2: # player 0 - 3 com  OR player 1 - 2 com
                # easy
                self.create_instructions_easy()  
        
        # if round 6
        elif player_score + com_score == 5:
            dif = player_score - com_score
            if dif == 1: # player 3 - 2 com
                # medium
                self.create_instructions_medium()
                
            elif dif == -1: # player 2 - 3 com
                # easy or medium
                if random.randint(0,9) >= 5:
                    self.create_instructions_easy()
                else:
                    self.create_instructions_medium()
                
            elif dif == 5 or dif == 3: # player 5 - 0 com OR player 4 - 1 com
                # hard or extra
                self.create_instructions_hard()
                
            elif dif == -5 or dif == -3: # player 0 - 5 com  OR player 1 - 4 com
                # easy
                self.create_instructions_easy()  
                
        # if round 7
        elif player_score + com_score == 6:
            dif = player_score - com_score
            if dif == 0: # player 3 - 3 com
                # easy or medium
                if random.randint(0,9) >= 5:
                    self.create_instructions_easy()
                else:
                    self.create_instructions_medium()                
                
            elif dif == -2: # player 2 - 4 com
                # easy or medium
                if random.randint(0,9) >= 7:
                    self.create_instructions_easy()
                else:
                    self.create_instructions_medium()
                
            elif dif == 2: # player 4 - 2 com
                # hard
                self.create_instructions_medium()
                
            elif dif == 6 or dif == 4: # player 6 - 0 com OR player 5 - 1 com
                # extra
                self.create_instructions_hard()
                
            elif dif == -6 or dif == -4: # player 0 - 6 com  OR player 1 - 5 com
                # easy  
                self.create_instructions_easy()
                
        # if round 8
        elif player_score + com_score == 7:
            dif = player_score - com_score
            if dif == 1: # player 4 - 3 com
                # easy or medium
                if random.randint(0,9) >= 3:
                    self.create_instructions_easy()
                else:
                    self.create_instructions_medium()
                
            elif dif == -3 or dif == -1: # player 2 - 5 com OR player 3 - 4 com
                # easy or medium
                self.create_instructions_easy()
                
            elif dif == 3: # player 5 - 2 com
                # hard
                self.create_instructions_hard()
                
            elif dif == 7 or dif == 5: # player 7 - 0 com OR player 6 - 1 com
                # extra
                self.create_instructions_hard()
                
            elif dif == -7 or dif == -5: # player 0 - 7 com  OR player 1 - 6 com
                # easy  
                self.create_instructions_easy()
                
        # if round 9
        elif player_score + com_score == 8:
            dif = player_score - com_score
            if dif == 0: # player 4 - 4 com
                # easy or medium or hard
                if random.randint(0,9) >= 2:
                    self.create_instructions_easy()
                elif random.randint(0,9) > 2 and random.randint(0,9) <= 6:
                    self.create_instructions_medium()
                else:
                    self.create_instructions_hard()
            elif dif == -4 or dif == -2: # player 2 - 6 com OR player 3 - 5 com
                # easy
                self.create_instructions_easy()
                
            elif dif == 2: # player 5 - 3 com
                # hard
                self.create_instructions_medium()
                
            elif dif == 6 or dif == 4: # player 7 - 1 com OR player 6 - 2 com
                # extra
                self.create_instructions_hard()
                
            elif dif == 8: # player 8 - 0 com
                # extra 
                if random.randint(0,9) >= 5:
                    self.create_instructions_easy()
                else:
                    self.create_instructions_medium()
                
            elif dif == -8 or dif == -6: # player 0 - 8 com  OR player 1 - 7 com
                self.create_instructions_easy() # easy
                 

        self.state = self.DANCING
        return self.instructions

    def create_instructions_easy(self):
        self.instructions = []
        number_of_movements = random.randint(3,4)
        for a in range(number_of_movements):
            inst = random.randint(0,8)
            speed = 8
            self.instructions.append(Instruction.Instruction(inst, speed))
    
    def create_instructions_medium(self):
        self.instructions = []
        number_of_movements = random.randint(4,5)
        for a in range(number_of_movements):
            inst = random.randint(0,8)
            if random.randint(0,9) >= 5:
                speed = 8
            else:
                speed = 2
            self.instructions.append(Instruction.Instruction(inst, speed))
    
    def create_instructions_hard(self):
        self.instructions = []
        number_of_movements = random.randint(5,6)
        for a in range(number_of_movements):
            inst = random.randint(0,8)
            if random.randint(0,9) >= 5:
                speed = 8
            else:
                speed = 2
            self.instructions.append(Instruction.Instruction(inst, speed))
    
    def create_instructions_extra(self):
        self.instructions = []
        number_of_movements = random.randint(6,7)
        for a in range(number_of_movements):
            inst = random.randint(0,8)
            if random.randint(0,9) >= 5:
                speed = 8
            else:
                speed = 2
            self.instructions.append(Instruction.Instruction(inst, speed))
        
    def get_state(self):
        return self.state
    
    def update(self):
        if self.counter > 0:
            self.counter = self.counter - 1
        else:
            if len(self.instructions)>0:
                instruction = self.instructions[0]
                self.instructions.pop(0)
                if instruction.get_movement() == Instruction.Instruction.LEFT_UP:
                    self.dancer.move_left_up(instruction.get_speed()); 
                    self.counter = 10 + instruction.get_speed()
                elif instruction.get_movement() == Instruction.Instruction.UP:
                    self.dancer.move_up(instruction.get_speed());
                    self.counter = 10 + instruction.get_speed()
                elif instruction.get_movement() == Instruction.Instruction.RIGHT_UP:
                    self.dancer.move_right_up(instruction.get_speed());
                    self.counter = 10 + instruction.get_speed() 
                elif instruction.get_movement() == Instruction.Instruction.LEFT:
                    self.dancer.move_left(instruction.get_speed());
                    self.counter = 10 + instruction.get_speed()
                elif instruction.get_movement() == Instruction.Instruction.MIDDLE:
                    self.dancer.move_middle(instruction.get_speed());
                    self.counter = 10 + instruction.get_speed()
                elif instruction.get_movement() == Instruction.Instruction.RIGHT:
                    self.dancer.move_right(instruction.get_speed());
                    self.counter = 10 + instruction.get_speed()
                elif instruction.get_movement() == Instruction.Instruction.LEFT_DOWN:
                    self.dancer.move_left_down(instruction.get_speed());
                    self.counter = 10 + instruction.get_speed() 
                elif instruction.get_movement() == Instruction.Instruction.DOWN:
                    self.dancer.move_down(instruction.get_speed());
                    self.counter = 10 + instruction.get_speed() 
                elif instruction.get_movement() == Instruction.Instruction.RIGHT_DOWN:
                    self.dancer.move_right_down(instruction.get_speed());
                    self.counter = 10 + instruction.get_speed()
            else:
                self.state = self.END_DANCING