'''
Created on 09/04/2011

@author: emea
'''
import pygame
import sys
import os
import data
import AnimatedSprite
import SpriteSheet
import Dancer

class EndCom(object):
    def __init__(self, screen, music):
        self.INTRO_IMAGE1 = data.filepath("background.png")
        self.GIRL = data.filepath("Girl.png")
        self.BARMAN = data.filepath("Barman.png")
        self.PLAYER_DANCER = data.filepath("DancingPlayerSprites.png")
        self.SALSA = data.filepath("DancingComSprites.png")
        self.HEART = data.filepath("Heart.png")
        self.MUSIC_FILE = data.filepath("MyLatinDanceClass.ogg")
        
        self.music = music
        if self.music:
            pygame.mixer.music.load(self.MUSIC_FILE) 

        self.screen = screen
        self.intro_image1 = pygame.image.load(self.INTRO_IMAGE1).convert()
        

        self.girl = AnimatedSprite.AnimatedSprite(SpriteSheet.images_list(170,240, self.GIRL))
        self.girl_rect = self.girl.image.get_rect()
        self.girl_rect.x = 320
        self.girl_rect.y = 200
        
        self.barman = AnimatedSprite.AnimatedSprite(SpriteSheet.images_list(80,90, self.BARMAN))
        self.barman_rect = self.barman.image.get_rect()
        self.barman_rect.x = 55
        self.barman_rect.y = 165
        
        self.player = AnimatedSprite.AnimatedSprite([SpriteSheet.image_at(0, 170, 240, self.PLAYER_DANCER), SpriteSheet.image_at(1, 170, 240, self.PLAYER_DANCER)])
        self.player_rect = self.player.image.get_rect()
        self.player_rect.x = 100
        self.player_rect.y = 330
        
        self.heart = AnimatedSprite.AnimatedSprite(SpriteSheet.images_list(50,50, self.HEART))
        self.heart_rect = self.heart.image.get_rect()
        self.heart_rect.x = 380
        self.heart_rect.y = 180
        
        self.font = pygame.font.Font(data.filepath("VT321.ttf"), 80)
        self.text_image1 = self.font.render("You lose!", 1, (255, 255, 255))
        self.text_image1_rect = self.text_image1.get_rect()
        self.text_image1_rect.centerx = 400
        self.text_image1_rect.centery = 150
        
        self.com_dancer = Dancer.Dancer(self.screen, "computer")
        
        self.clock = pygame.time.Clock()   
        

    def quit(self):
        '''Exit the game
        '''
        
        sys.exit()
    
    def start(self):
        self.intro = self.intro_image1
        bg_rect = self.intro_image1.get_rect()
        counter = 0
        skip_intro = False
        while True:
            if self.music:
                if not pygame.mixer.music.get_busy():
                    pygame.mixer.music.play()
            time_passed = self.clock.tick(30)

            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    self.quit()
                elif event.type == pygame.KEYDOWN:
                    if event.key == pygame.K_ESCAPE or event.key == pygame.K_q:
                        if self.music:
                            pygame.mixer.music.fadeout(400)
                        skip_intro = True
            if skip_intro == True:
                break
            
            if counter > 0 and counter < 50:
                pass
            if counter > 50 and counter < 95:
                self.girl_rect.x = self.girl_rect.x + 3
                self.girl_rect.y = self.girl_rect.y + 3
                self.heart_rect.x = self.heart_rect.x + 3
                self.heart_rect.y = self.heart_rect.y + 3
            if counter > 150:
                if self.music:
                    pygame.mixer.music.fadeout(400)
                break
            
            self.barman.update(pygame.time.get_ticks())
            #self.player.update(pygame.time.get_ticks())
            self.girl.update(pygame.time.get_ticks())
            self.heart.update(pygame.time.get_ticks())
            self.com_dancer.update()
                
            
            counter = counter + 1
            self.screen.blit(self.intro, bg_rect)

            self.com_dancer.draw()
            self.screen.blit(self.heart.image, self.heart_rect)
            self.screen.blit(self.girl.image, self.girl_rect)
            self.screen.blit(self.barman.image, self.barman_rect)
            self.screen.blit(self.player.image, self.player_rect)
            self.screen.blit(self.text_image1, self.text_image1_rect)
            
            pygame.display.flip()