'''
Created on 03/04/2011

@author: emea
'''
#import random
import pygame
from pygame.locals import *
from Option import Option
from Cursor import Cursor
import os
import Play
import sys
import data
import Instructions
import EndPlayer
import EndCom
import Credits

class Menu(object):
 
    def __init__(self, screen, music):
        self.screen = screen
        self.music = music
        
        options = [
                    ("Play", self.start_game),
                    ("Credits", self.credits),
                    ("Exit", self.exit)
                    ]
        self.options = []
        
                    
        font1 = pygame.font.Font(data.filepath("VT321.ttf"), 20)
        font2 = pygame.font.Font(data.filepath("VT321.ttf"), 30)
        
        x = 375
        y = 275
        parity = 1
 
        self.cursor = Cursor(x - 50, y - 20, 30)
 
        for title, function in options:
            self.options.append(Option(font1, font2, title, x, y, parity, function, self.screen))
            y += 30
            if parity == 1:
                parity = -1
            else:
                parity = 1
 
        self.selected = 0
        self.total = len(self.options)
        self.keep_pressed = False
        
        self.ending_player = EndPlayer.EndPlayer(self.screen, self.music)
        self.ending_com = EndCom.EndCom(self.screen, self.music)
 
    def update(self):
 
        k = pygame.key.get_pressed()
 
        if not self.keep_pressed:
            if k[K_UP]:
                self.selected -= 1
            elif k[K_DOWN]:
                self.selected += 1
            elif k[K_RETURN]:
                # call the function associated to the option
                self.options[self.selected].activate()
 
        if self.selected < 0:
            self.selected = 0
        elif self.selected > self.total - 1:
            self.selected = self.total - 1
 
        self.cursor.select(self.selected)
        
        for i in range(len(self.options)):
            if self.selected == i:
                self.options[i].mark(True)
            else:
                self.options[i].mark(False)
        self.keep_pressed = k[K_UP] or k[K_DOWN] or k[K_RETURN]
        
        self.cursor.update()
        
        for o in self.options:
            o.update()
 
    def printScreen(self):
        self.cursor.printScreen(self.screen)
 
        for option in self.options:
            option.printScreen()
            
    def start_game(self):
        instructions = Instructions.Instructions(self.screen)
        instructions.start()
        play = Play.Play(self.screen, self.music)
        #play = Play.Play(self.screen, True)
        #play = Play.Play(self.screen, False)
        result = play.play()
        if result == Play.Play.GAME_STOPPED:
            pass
        elif result == Play.Play.WIN_PLAYER:
            self.ending_player.start()
        elif result == Play.Play.WIN_COM:
            self.ending_com.start()

 
    def credits(self):
        credits = Credits.Credits(self.screen)
        credits.start()
 
    def exit(self):
        # force to close; I don't know why the sys.exit(0) doesn't work correctly
        os._exit(0)
        #sys.exit(0)

    def start(self):
        exit = False
        background = pygame.image.load(data.filepath("background_dif.png")).convert()
 
        while not exit:
 
            for e in pygame.event.get():
                if e.type == QUIT:
                    exit = True
            
            
            self.screen.blit(background, (0, 0))
            self.update()
            self.printScreen()
 
            pygame.display.flip()
            pygame.time.delay(10)